<?
// $Id: catalogo_loop.inc.php,v 1.2 2009/05/07 13:35:38 calicant Exp $

/**
 ** tag: catalogsearchresults
 ** desc: stampa una lista di risultati di ricerca in catalogo
 ** desc: tra i tag lineari che e` possible inserire nella lista dei risultati
 ** desc: {id}: ide della pagina in cui si trova il catalogo
 ** desc: {startpage}: la pagina in cui si trova la scheda trovata nella ricerca
 ** desc: {nitem}: id della scheda trovata
 ** desc: {nome_cat}: il nome del catalogo
 ** desc: {descr}: descrizione della scheda (utile per grarantire che dati del catalogo trovato siano comunque presenti)
 ** desc: {nomecampo}: e` possibile richiamare nei risultati ogni campo del catalogo indicandone il nome
 ** opt: noparse (yes|no) se nei risultaty e' presente codice html viene mostrato tale e quale (default: yes)
 ** eg: <%risultaticatalogo noparse="yes"%>
 ** eg: <hr size="1" noshade> o <a href="index.php?id={id}&cat_vis_start={startpage}#{nitem}" CLASS="menutop">{nitem}{name_cat}</a><br/>
 ** eg: <div class="testo">{descr} - {nomecampo1} {nomecampo2}</div>
 ** eg: <%end%>
 **/
function catalogsearchresults (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

    if (trim($options["noparse"]) == "")
        $options["noparse"] = "yes";

    if ($PRISCILLA_SESSION->exists('priscilla_catalog_search')) {

        $priscilla_catalog_search = $PRISCILLA_SESSION->getvalue('priscilla_catalog_search');

        $quanti = count($priscilla_catalog_search);

        // ci prendiamo il nome del catalogo e la lingua
        $cat_lang = '';
        $gid = $priscilla_catalog_search[0]['id_cat'];
        if (is_numeric($gid) && $gid) {
            $dbquery = "SELECT nome, lang, id_user FROM catalogo WHERE id = '$gid'";
            $elenco_catalogo = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

            if ($elenco_catalogo->RecordCount()) {

                $nome_catalogo = $elenco_catalogo->fields('nome');
                $cat_lang = $elenco_catalogo->fields('lang');
                $cat_user = $elenco_catalogo->fields('id_user');

                if ($cat_lang == '') {
                    $dbquery = "SELECT lingua FROM user WHERE username = '$cat_user'";
                    $rs = $connh->Execute($dbquery) or die("<br />ERROR: $query<br />". $connh->ErrorMsg());
                    $cat_lang = $rs->fields('lingua');
                }
                } else $nome_catalogo = $gid;
            } else $nome_catalogo = $gid;

        if ($cat_lang == '') {
        if (isset($lang) && trim($lang) != '')
            $cat_lang = $lang;
        else
            $cat_lang = 'ita';
       }

        require "modules/catalogo/lang/$cat_lang/catalogo.diz";

        if ($quanti < 1) {
            $rowR[descr] = catalog_search_resultsno;
            $publisher->publish($blocco, $risoluzione, $rowR);
        } else {
            // ci prendiamo il nome del catalogo

            echo "<strong>" . catalog_search_noresults . ": " . $quanti . "</strong><br />\n";

            for ($i = 0; $i < count($priscilla_catalog_search); $i++) {

                unset($rowR);

                $rowR['id']           = $priscilla_catalog_search[$i]['id_cat'];
                $rowR['nitem']        = $priscilla_catalog_search[$i]['nitem'];
                $rowR['startpage']    = $priscilla_catalog_search[$i]['startpage'];
                $rowR['descr']        = $priscilla_catalog_search[$i]['descr'];
                $rowR['name_cat']     = $priscilla_catalog_search[$i]['name_cat'];

                $dbquery = "SELECT * FROM catalogo_content WHERE id = '" . $rowR['nitem'] . "' AND content_visible = '1'";
                $rowRrs = $connh->Execute($dbquery) or die ("Error: " . $connh->ErrorMsg);

                if ($rowRrs->RecordCount()) {
                    $rowRadd = $rowRrs->fields;
                    unset($rowRadd['id']);
                    unset($rowRadd['gid']);
                    unset($rowRadd['content_visible']);
                    unset($rowRadd['da']);
                    unset($rowRadd['a']);

                    foreach ($rowRadd as $addK=>$addV)
                        if (!isset($rowR[$addK]))
                            $rowR[$addK] = $addV;
                }

                if ($options["noparse"] == 'yes')
                    $rowR['string'] = htmlentities($rowR['string']);

                $publisher->publish($blocco, $risoluzione, $rowR);
            } // for
        } // else
        $PRISCILLA_SESSION->remove('priscilla_catalog_search');
        unset($priscilla_catalog_search);
    } // if

}

/**
 ** tag: catalogcategorize
 ** desc: stampa una lista di possibili valori di un dato campo di catalogo
 ** opt: id id del catalogo [richiesto]
 ** opt: field campo del catalogo di cui esplorare i valori [richiesto]
 ** eg: per ogni valore possibile viene dato anche il numero delle occorrenze
 ** eg: campi da richiamare sono
 ** eg: {catname} uno dei possibili valori del campo
 ** eg: {catcount} numero di occorrenze della categoria
 ** eg: <%catalogcategorize id="1" field="quartiere"%>
 ** eg: {catname} ({catcount})
 ** eg: <%end%>
 **/
function catalogcategorize (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {


	if (is_numeric($options["id"]) && trim($options["field"]) != "") {

		$f = $options["field"];
		$id = $options["id"];
		$catsearchid = $options["searchid"];

		$dbquery = "SELECT `$f` FROM `catalogo_content` WHERE `content_visible` = 1 AND `gid` = $id ORDER BY `$f` ASC";

		$rs = $connh->Execute($dbquery);

		if ($rs && $rs->RecordCount()) {

			$a_categories = array();
			while (!$rs->EOF) {

				$cat = strtolower(trim($rs->fields($f)));

				if ($cat != "") {
					if (!isset($a_categories[$cat]))
						$a_categories[$cat] = 1;
					else
						$a_categories[$cat]++;
				}

				$rs->MoveNext();
			} // while
		} // if


		// fuori i risultati
		foreach ($a_categories as $catname => $catcount) {

			$rowR = array();

			$rowR["catname"] = $catname;
			$rowR["catcount"] = $catcount;
			$rowR["catid"] = $id;
			$rowR["searchid"] = $catsearchid;
			$rowR["catalogpage"] = $_GET["id"];

                	$publisher->publish($blocco, $risoluzione, $rowR);
		}

	} // if (is_numeric
}

/**
 ** tag: catalogfilter
 ** desc: stampa una lista di schede che hanno un campo con valore dato
 ** opt: catalogid id del catalogo [richiesto] [via GET]
 ** opt: field campo del catalogo su cui filtrare [richiesto] [via GET]
 ** opt: value valore del campo [richiesto] [via GET]
 ** opt: catalogpage id della pagina di priscilla in cui si trova il catalogo [via GET]
 ** eg: le opzioni debbono essere passate via GET
 ** eg: eventuali opzioni passate come parametri del tag sono comunque sovrascritte dai valori che provengono via GET
 ** eg: index.php?id=12&field=quartiere&value=pratello
 ** eg: dove nel modello della pagina avente id 12 si ha:
 ** eg: <%catalogfilter%>
 ** eg: {campocatalogo1} {campocatalogo2}
 ** eg: <%end%>
 **/
function catalogfilter (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

	require_once "modules/catalogo/lib/catalog.lib.php";

	$catalogid = $options["catalogid"];
	$field = $options["field"];
	$value = $options["value"];

	if (is_numeric($_GET["catalogid"])) {
		$catalogid = $_GET["catalogid"];
		$cs_catalog_index = make_index_for_catalog_pages($catalogid);
		$cs_catalog_index_num = count($cs_catalog_index);
	}		

	if (trim($_GET["field"]) != "")
		$field = $_GET["field"];

	if (trim($_GET["value"] != ""))
		$value = $_GET["value"];

	if (is_numeric($_GET["catalogpage"]))
		$catalogpage = $_GET["catalogpage"];
	

	$catalog_name = "";
	$dbquery = "SELECT `nome` FROM `catalogo` WHERE `id` = $catalogid LIMIT 1";
	$rs = $connh->Execute($dbquery);
	if ($rs && $rs->RecordCount())
		$catalog_name = $rs->fields('nome');


	if (is_numeric($catalogid) && trim($field) != "" && trim($value) != "") {

		$dbquery = "SELECT * FROM `catalogo_content` WHERE `content_visible` = 1 AND `gid` = $catalogid AND `$field` = '$value'";
		$rs = $connh->Execute($dbquery);

		if ($rs && $rs->RecordCount()) {
			while (!$rs->EOF) {


                        	$urlstuff = 'id=' . $catalogpage;
                        	$id_cat = $catalogid;
                        	if ($cs_catalog_index_num) {
                       			$urlstuff .= '&cat_vis_start=' . $cs_catalog_index[$rs->fields('id')];
                                	$nsubpage = $cs_catalog_index[$rs->fields('id')];
                        	} // if ($cs_catalog_index_num
                        	else $nsubpage = 0;                                                

				$rowR = $rs->fields;

				$rowR["catalogpage"] = $catalogpage;
				$rowR["id_cat"] = $id_cat;
				$rowR["nitem"] = $rs->fields('id');
				$rowR["startpage"] = $nsubpage;


				// echo "nitem = " . $rowR["nitem"] . " id_cat = " . $rowR["id_cat"] . " startpage = " . $rowR["startpage"] . "<br />";

				if ($rowR["id_image"] && $catalog_name != "") {
					$id_image = $rowR["id_image"];
					$dbquery = "SELECT `nome` FROM `catalogo_immagini` WHERE `id_image` = $id_image LIMIT 1";
					$rsi = $connh->Execute($dbquery);
					if ($rsi && $rsi->RecordCount()) {

						// catalogo/bar/mini/larkingrimm_parplar_coverart_1.jpg 
						//<img src="catalogo/bar/mini/larkingrimm_parplar_coverart_1.jpg" alt="" style="margin-left:0;margin-right:0;margin-bottom:0;margin-top:0;border:0px;" width="100" height="52" />
						$rowR["image_mini"] = "<img src=\"" . "catalogo/" . $catalog_name . "/mini/" . $rsi->fields('nome') . "\" />";
						
					}
				}
				

                		$publisher->publish($blocco, $risoluzione, $rowR);
				$rs->MoveNext();

			}
		}

	}
	
}

?>
