<?

class feed_parser
{
    var $xml_parser;
    var $url;
    var $fp;
    var $encoding;

    var $item_tags;
    var $channel_tags;

    var $feed_items;
    var $feed_channel;
    var $context;
    var $current_el;

    var $debug = false;

    function feed_parser($param)
    {
        static $instance;

        if (isset($instance[$param['url']]))
            return $instance[$param['url']];

        $this->mag_q = get_magic_quotes_runtime();
        set_magic_quotes_runtime(0);

        $this->url = $param['url'];
        $this->fp = file($param['url']);

        if ($this->debug)
            $this->out_debug("Lette ".count($this->fp)." righe da ".$this->url);

        if (!$param['encoding']) {
            preg_match_all('/<\?xml\s+(version="(.*)")?\s+(encoding="(.*)")?\s*\?>/iU', $this->fp[0], $match);
            if ($match[4][0]) // ho encoding settato
                $this->encoding = $match[4][0];
        }
        else
            $this->encoding = $param['encoding'];

        if ($this->debug)
            $this->out_debug("Encoding ".$this->encoding);

        $this->xml_parser = xml_parser_create($this->encoding);
        xml_parser_set_option($this->xml_parser, XML_OPTION_SKIP_WHITE, 1);
        xml_parser_set_option($this->xml_parser, XML_OPTION_CASE_FOLDING, 1);
        xml_set_object($this->xml_parser, $this);
        xml_set_element_handler($this->xml_parser, "start_tag", "end_tag");
        xml_set_character_data_handler($this->xml_parser, "feed_content"); 

        $this->pointer = 0;

        $this->channel_tags = array('TITLE', 'LINK', 'DESCRIPTION', 'GENERATOR', 'PUBDATE');
        $this->item_tags = array('TITLE', 'DESCRIPTION', 'GUID', 'PUBDATE', 'LINK', 'DC:DATE', 'AUTHOR', 'CATEGORY', 'COMMENTS', 'ENCLOSURE', 'SOURCE');

        $this->context = '';
        $this->parse();
        set_magic_quotes_runtime($this->mag_q);

        $instance[$param['url']] = $this;
    }

    function start_tag($parser, $el, $attr)
    {
        $this->current_el = $el;
        if ($el == 'ITEM') {
            $this->context = 'item';
            $this->feed_items[$this->pointer] = array();
        }
        else if ($el == 'CHANNEL') {
            $this->context = 'channel';
            $this->feed_channel = array();
        }

        if ($this->debug)
            $this->out_debug("start_tag - current el ".$this->current_el.", context ".$this->context);
    }

    function feed_content($parser, $data)
    {
        $data = trim($data);
        $k = str_replace(':', '', strtolower($this->current_el));
        if ($this->context == 'item' && in_array($this->current_el, $this->item_tags))
            $this->feed_items[$this->pointer][$k] .= ' '.$data;
        else if ($this->context == 'channel' && in_array($this->current_el, $this->channel_tags))
            $this->feed_channel[$k] .= ' '.$data;

        if ($this->debug)
            $this->out_debug("feed_content - current el ".$this->current_el.", context ".$this->context);
    }

    function end_tag($parser, $el)
    {
        if ($this->debug)
            $this->out_debug("end_tag - current el ".$this->current_el.", context ".$this->context.", pointer ".$this->pointer);

        $this->current_el = '';
        if ($el == 'ITEM') {
            $this->pointer += 1;
            $this->context = '';
        }
        if ($el == 'CHANNEL')
            $this->context = '';
    }

    function parse()
    {
        foreach ($this->fp as $i => $data) {
            if ($this->debug)
                $this->out_debug("parse - line <strong>$i</strong> data <em>".htmlspecialchars($data)."</em>");
            if (!xml_parse($this->xml_parser, $data, false)) {
                $msg = sprintf('XML error at line %d column %d', xml_get_current_line_number($this->xml_parser), xml_get_current_column_number($this->xml_parser));
                if ($this->debug)
                    $this->out_debug("parse - ERROR ".$msg);
                return $msg;
            }
        }
        xml_parser_free($this->xml_parser);

        $this->pointer = 0;

        return true;
    }

    function next_item()
    {
        if ($this->pointer > count($this->feed_items))
            return false;
        else {
            return $this->feed_items[$this->pointer++];
        }
    }

    function channel_info($key)
    {
        return $this->feed_channel[$key];
    }

    function out_debug($str)
    {
        static $c = 0;
        echo "<br /><strong>&gt;$c</strong>: ".$str;
        $c++;
    }

}

//$f_p = new feed_parser(array('url' => 'http://feedproxy.google.com/ziobudda/heiu?format=xml'));
//$f_p = new feed_parser(array('url' => 'http://mano/antonio/priscilla1/modules/feeds/feed.xml?id=3'));
//$f_p = new feed_parser(array('url' => 'http://www.repubblica.it/rss/scienza_e_tecnologia/rss2.0.xml'));
//$f_p = new feed_parser(array('url' => 'http://www.w3.org/2000/08/w3c-synd/home.rss'));
//$f_p = new feed_parser(array('url' => 'http://rss.slashdot.org/Slashdot/slashdot'));
/*while ($item = $f_p->next_item()) {
    echo "<pre>";print_r($item);echo "<pre>";
}*/

?>
