<?
//$Id: paper_loop.inc.php,v 1.10 2010/02/25 11:16:07 antonio Exp $

require_once PRISCILLA_LOCAL_PATH."modules/paper/inc/config.inc.php";

/**
 ** tag: papernewshome
 ** desc: utilizzato per ciclare le ultime n pagine appartenenti al livello specificato. Per ogni campo della tabella di contenuto associata al nodo crea anche un corrispettivo <nomecampo>_extract, che contiene il primo paragrafo (<p>) incontrato nel testo
 ** opt: level livello da cui prelevare le pagine
 ** opt: n numero di pagine da prelevare
 ** opt: orederby campo di ordinamento (vedi campi tabella node)
 ** opt: orderdir direzione dell'ordinamento asc|desc
 ** opt: show nodes|news se specificato visualizza solo le pagine del tipo specificato
 ** opt: highlight se presente deve contenere il colore rgb per evidenziare il titolo della pagina corrente
 ** opt: extract intero, se specificato <nomecampo>_extract contiene i primi n caratteri trovati nel testo
 ** eg: <%papernewshome show="news" level="2" n="3"%>
 ** eg: <br /><a href="index.php?id={id}" accesskey="{accesskey}">{titolo}</a>
 ** eg: <%end%>
**/
function papernewshome(&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{
    if (!isset($options['level'])) $options['level'] = 1;
    $n = isset($options['n']) ? $options['n'] : PAPER_HOMENEWS_DEFAULT_N;
    $orderby = isset($options['orderby']) ? $options['orderby'] : PAPER_HOMENEWS_DEFAULT_ORDER_FIELD;
    $orderdir = isset($options['orderdir']) ? $options['orderdir'] : PAPER_HOMENEWS_DEFAULT_ORDER_DIR;

    if ($orderby != '') $order_query = "ORDER BY ".$orderby." ".$orderdir;
    $where = '';

    if ($options['show'] == 'news') $where = 'and (isanews=1 || isanews=2)';
    elseif ($options['show'] == 'nodes') $where = 'and (isanews=0 || isanews=2)';

    $query = "SELECT * FROM node LEFT JOIN ".PAPER_HOMENEWS_CONTENT_TABLE." ON ".PAPER_HOMENEWS_CONTENT_TABLE.".id=node.id WHERE CURDATE() >= `".PAPER_HOMENEWS_DATEIN_FIELD."` and CURDATE() < `".PAPER_HOMENEWS_DATEOUT_FIELD."` and `".PAPER_HOMENEWS_LEVEL_FIELD."`='".$options['level']."' $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] $where ".$order_query." LIMIT 0,".$n;

    $rs = $connh->Execute($query) or die("ERRORE:".$connh->ErrorMsg());
    while (!$rs->EOF)
    {
        $row = $rs->fields;

        if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content') != SWAPLANG_DEFAULT_CONTENT)
        $row['contenuto'] = $row['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

        $rscontent = $connh->Execute("SELECT * FROM ".$row['contenuto']." WHERE id='".$row['id']."'");
        if ($rscontent->RecordCount() > 0)
            $row = array_merge($rscontent->fields, $row);

        foreach ($row as $field => $value) {
            $index = $field.'_extract';

            if ($options['extract'] > 0) {
                if ($value{$options['extract']} == ' ')
                    $row[$index] = substr($value, 0, $options['extract']);
                else {
                    $char = '';
                    $pos = $options['extract'] + 1;
                    while ($char != ' ' && $pos <= strlen($value)) {
                        $char = $value{$pos};
                        $pos++;
                    }
                    $row[$index] = substr($value, 0, $pos);
                }
            }
            else
                if (is_string($value) && strstr($value, '</p>')) {
                    preg_match('/<p\s*[\w\W]*>([\w\W]*)<\/p>/Umi', $value, $matches);
                    $row[$index] = $matches[1];
                }
        }

        // param highlight
        if ($options['highlight'] != '')
        {
            if ($row['id'] == $content['id'])
                $row['titolo'] = "<span style=\"color:".$options['highlight']."\">".$row['titolo']."</span>";
        }

        $publisher->publish($blocco, $risoluzione, $row);
        $rs->MoveNext();
    }
}

/**
 ** tag: papertematicareas
 ** desc: utilizzato per ciclare le aree tematiche del sito
 ** opt: orederby campo di ordinamento (vedi campi tabella node)
 ** opt: orderdir direzione dell'ordinamento asc|desc
 ** opt: highlight se presente deve contenere il colore rgb per evidenziare il titolo della pagina corrente
 ** opt: expand se impostato a yes fornisce all'interno del loop il tag {expand} con la list (ul) delle pagine appartenenti all'area tematica corrente
 ** eg: <%papertematicareas expand="yes"%>
 ** eg: <br /><a href="index.php?id={id}" accesskey="{accesskey}">{titolo}</a>{expand}
 ** eg: <%end%>
**/
function papertematicareas(&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{
    if ($options['orderby']) $order = $options['orderby'];
    else $order = "rilevanza";
    if ($options['orderdir']) $orderdir = $options['orderdir'];
    else $orderdir = "DESC";
    $order_query = "ORDER BY ".$order." ".$orderdir;

    $rs = $connh->Execute("SELECT * FROM node WHERE `node`.areatematica=`node`.sezione $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] $order_query $limit");
    if ($rs->RecordCount()) while (!$rs->EOF)
    {
        // per avere il titolo originale della pagina (pro match areatematica)
        $rscorig = $connh->Execute("SELECT titolo FROM ".$rs->fields['contenuto']." WHERE id='".$rs->fields['id']."'");
    
        if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content') != SWAPLANG_DEFAULT_CONTENT)
            $rs->fields['contenuto'] = $rs->fields['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

        $rsc = $connh->Execute("SELECT * FROM ".$rs->fields['contenuto']." WHERE id='".$rs->fields['id']."'");
        if ($rsc->RecordCount() > 0)
            $row = array_merge($rs->fields, $rsc->fields);
        else
            $row = $rs->fields;

        $row['correntearea'] = '';
        if ($row['id'] == $_GET['id'] || stripslashes($rscorig->fields['titolo']) == stripslashes($content['areatematica'])) {
            $row['correntearea'] = 'correntearea';
        }
        
        // param expand
        if ($options['expand'] == 'yes') {
            if ($content['id'] == $row['id'] ||
            ($content['areatematica'] == $PRISCILLA_SESSION->getvalue('expandedArea')
            && $rscorig->fields['titolo'] == $content['areatematica']) || $row['id'] == $_GET['from']) {
                $PRISCILLA_SESSION->add('expandedArea', $row['areatematica']);

                $query = "SELECT * FROM node LEFT JOIN `".$row['contenuto']."` ON (node.id=`".$row['contenuto']."`.id) WHERE `node`.areatematica='".addslashes($row['titolo'])."' and `".$row['contenuto']."`.titolo!=`node`.areatematica $GLOBALS[extra] $GLOBALS[daa] $GLOBALS[community] and ((segnalibro is null) or (segnalibro = '')) and ((navigatore is null) or (navigatore = '')) $where $order_query $limit";
                $rs2 = $connh->Execute($query) or die($query."<br />".$connh->ErrorMsg());
                if ($rs2->RecordCount() > 0) {
                    $row[expand] .= "<ul>";
                    while (!$rs2->EOF) {
                        $row[expand] .= "<li><a href=\"index.php?id=".$rs2->fields('id')."\" class=\"expand\"";

                        $row[expand] .= ">";
                        if ($options['class'] != '' && $content[id] == $rs2->fields('id'))
                            $row[expand] .=  "<span style=\"color:".$options['class']."\">";
                        $row[expand] .= $rs2->fields['titolo'];
                        if ($options['class'] != '' && $content[id] == $rs2->fields('id'))
                            $row[expand] .=  "</span>";
                        $row[expand] .= "</a></li>\n";
                        $rs2->MoveNext();
                    }
                    $row[expand] .= "</ul>";
                    if ($content[areatematica] == $row[areatematica]) {
                        $PRISCILLA_SESSION->add('expandedArea', $row[areatematica]);
                    }
                }
            }
        }

        // param highlight
        if ($options['highlight'] != '')
        {
            if ($row['id'] == $content['id'])
                $row['titolo'] = "<span style=\"color:".$options['highlight']."\">".$row['titolo']."</span>";
        }

        //$rsc = $connh->Execute("SELECT * FROM ".$row['contenuto']." WHERE id='".$row['id']."'");
        //$row = array_merge($row, $rsc->fields);

        $publisher->publish($blocco, $risoluzione, $row);
        $rs->MoveNext();
    }
}

/**
 ** tag: paperareasons
 ** desc: cicla su tutte le pagine appartenenti all'area tematica specificata
 ** opt: area id o titolo dell'area protagonista, se vuoto pagina corrente
 ** opt: n numero di pagine da prelevare
 ** opt: orederby campo di ordinamento (vedi campi tabella node)
 ** opt: orderdir direzione dell'ordinamento asc|desc
 ** opt: show nodes|news se specificato visualizza solo le pagine del tipo specificato
 ** opt: get strict|supp|all default strict, cioè mostra solo le pagine che hanno l'area tematica assegnata come prima scelta. Fornendo supp vengono estratte solo le pagine che hanno segnato l'area tematica come secondaria. Se viene specificato all vengono estratte sia le pagine che hanno l'area tematica assegnata come supplementare che come primaria
 ** opt: highlight se presente deve contenere il colore rgb per evidenziare il titolo della pagina corrente
 ** eg: <%paperareasons show="nodes"%>
 ** eg: <br /><a href="index.php?id={id}" accesskey="{accesskey}">{titolo}</a>
 ** eg: <%end%>
**/
function paperareasons(&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco)
{
    if ($options['area'] == '') {
        if ($content['areatematica'])
            $options['area'] = $content['areatematica'];
        else {
            $rs = $connh->Execute("SELECT `".$content['contenuto']."`.titolo FROM node LEFT JOIN `".$content['contenuto']."` ON (node.id=`".$content['contenuto']."`.id) WHERE `node`.id='".$content['id']."' and `node`.areatematica=`node`.sezione");
            if (!$rs || !$rs->RecordCount())
                return;
            $options['area'] = $rs->fields['titolo'];
        }
    }

    $where = '';

    if ($options['orderby']) $order = $options['orderby'];
    else $order = "rilevanza";
    if ($options['orderdir']) $orderdir = $options['orderdir'];
    else $orderdir = "DESC";
    $order_query = "ORDER BY ".$order." ".$orderdir;

    if ($options['show'] == 'news') $where = 'and (isanews=1 || isanews=2)';
    elseif ($options['show'] == 'nodes') $where = 'and (isanews=0 || isanews=2)';

    if (is_numeric($options['area']) && $options['area']) {
        $rs = $connh->Execute("SELECT sezione FROM `node` WHERE id='".$options['area']."'");
        if (!$rs || !$rs->RecordCount())
            break;
        $options['area'] = $rs->fields['titolo'];
    }

    $query_join_areasupp = ''; $query_match_areasupp = ''; $query_where_area = '';
    switch ($options['get']) {
        case 'all':
        $query_where_area = "`node`.areatematica='".addslashes($options['area'])."'";
        $query_join_areasupp = "LEFT JOIN papernode ON (node.id=papernode.id)";
        $query_match_areasupp = "or MATCH (papernode.areesupplementari) AGAINST ('".$options['area']."')";
        break;
        case 'supp':
        $query_where_area = "";
        $query_join_areasupp = "LEFT JOIN papernode ON (node.id=papernode.id)";
        $query_match_areasupp = "MATCH (papernode.areesupplementari) AGAINST ('".$options['area']."')";
        break;
        default: //strict
        $query_where_area = "`node`.areatematica='".addslashes($options['area'])."'";
        $query_join_areasupp = "";
        $query_match_areasupp = "";
        break;
    }

    if ($options['n']) $limit = "LIMIT 0,".$options['n'];
    else $limit = '';

    $rs = $connh->Execute("SELECT * FROM `node` LEFT JOIN `".$content['contenuto']."` ON (node.id=`".$content['contenuto']."`.id) ".$query_join_areasupp." WHERE ($query_where_area $query_match_areasupp) and `node`.sezione!='".addslashes($options['area'])."' $where $order_query $limit");

    if ($rs->RecordCount()) while (!$rs->EOF)
    {
        if ($_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang') != '' && $_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang_content') != SWAPLANG_DEFAULT_CONTENT)
        $rs->fields['contenuto'] = $rs->fields['contenuto'].'_lang'.$_SESSION['PRISCILLA_SESSION']->getvalue('priscilla_swaplang');

        $rsc = $connh->Execute("SELECT * FROM ".$rs->fields['contenuto']." WHERE id='".$rs->fields['id']."'");
        if ($rsc->RecordCount() > 0)
            $row = array_merge($rs->fields, $rsc->fields);
        else
            $row = $rs->fields;

        // param highlight
        if ($options['highlight'] != '') {
            if ($row['id'] == $content['id'])
                $row['titolo'] = "<span style=\"color:".$options['highlight']."\">".$row['titolo']."</span>";
        }

        $publisher->publish($blocco, $risoluzione, $row);
        $rs->MoveNext();
    }
}

?>
